/*************************************************************************
* gui.h                                                                  *
* Maupatz     2001                                                       *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#ifndef  GUI_H
#define  GUI_H

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/keysym.h>
#include <errno.h>
#include <stdio.h>
#include <pthread.h>
#include <signal.h>
#include <sys/types.h>
#include <ctype.h>
#include "Imlib.h"

#define uint32_t unsigned long
#define xmalloc(size)  malloc(size)

#define XLOCK() { XLockDisplay (gDisplay); }
#define XUNLOCK() { XUnlockDisplay (gDisplay); }


typedef struct gui_move_s {
    int enabled;
    int offset_x;
    int offset_y;
} gui_move_t;

typedef struct gui_color_s {
    XColor red;
    XColor blue;
    XColor green;
    XColor white;
    XColor black;
    XColor tmp;
} gui_color_t;
gui_color_t gui_color;

typedef struct gui_image_s {
  Pixmap image;
  int width;
  int height;
} gui_image_t;

#define MWM_HINTS_DECORATIONS   (1L << 1)
#define PROP_MWM_HINTS_ELEMENTS 5

typedef struct _mwmhints {
  uint32_t flags;
  uint32_t functions;
  uint32_t decorations;
  int32_t  input_mode;
  uint32_t status;
} MWMHints;

extern Display         *gDisplay;
extern ImlibData       *gImlib_data;
extern Window          Video_window;

extern char skin_name[32];
int set_skin_name(char *s);
char *get_skin_name(char *s);
gui_image_t *gui_load_image(const char *image);

extern int init_gui(Display *d,Window w);
extern int end_gui(void);

#define SEND_KEVENT(key) {                                                    \
     static XEvent startevent;                                                \
     startevent.type = KeyPress;                                              \
     startevent.xkey.type = KeyPress;                                         \
     startevent.xkey.send_event = True;                                       \
     startevent.xkey.display = gDisplay;                                      \
     startevent.xkey.window = Video_window;                                   \
     XLOCK ();                                                                \
     startevent.xkey.keycode = XKeysymToKeycode(gDisplay, key);               \
     XSendEvent(gDisplay, Video_window, True, KeyPressMask, &startevent);     \
     XUNLOCK ();                                                              \
   }
   
#endif


