
/*********************************************************************************
 *                                                                               *
 * LaVache.h                                                                     *
 *                                                                               *
 * Copyright (C) 2000/2002 Fasouil                                               *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 * The author can be reached at fasouil@hotmail.com                              *
 *********************************************************************************/ 


#ifndef LAVACHEDEC_H
#define LAVACHEDEC_H

/////////////////////////////
	
//const int HauteurDecode_cy=287;
//const int HauteurBandeNoire=0;
/*
const char File_normalclef[]="normalclef2.fpc";		
const char File_accelereclef[]="accelereclef2.fpc";
const char File_accelerepos[]="accelerepos2.fpc";
const char File_normalpos[]="normalpos2.fpc";
const char File_chromiclef[]="chromiclef3.fpc";	
*/
/////////////////////////////////

#define TresholdNormalLimitSup		500*COEFFILTERLIMIT
#define TresholdNormalLimitInf		70*COEFFILTERLIMIT
#define TresholdNormalDynamicInf	10

#define TresholdPreviousLimitSup	600*COEFFILTERLIMIT
#define TresholdPreviousLimitInf	100*COEFFILTERLIMIT
#define TresholdPreviousDynamicInf	50


class CLaVache
{
public:
	CLaVache();
	~CLaVache();
	bool GetPhase();
	void SetSizeBuffer(int nSizeBufferX,int nSizeBuffery);
	bool IsInit();
	bool Init();
	bool FindKey(short ** ppsInputBuffer,short ** ppsOutputBuffer,BOOL bIsOdd,bool bPhaseFrame);
	bool SaveImage(short ** ppsBuffer1,short ** ppsBuffer2);
	bool LoadImage();
	void SetLoadImageMode(bool bUsedLoadImage);
	void DirectBufferCopy(short ** ppsInputBuffer,short ** ppsOutputBuffer,BOOL bIsOdd);
	double GetInfo();
	void Destroy();
	void SetParams(int nTestNormalUser,int nTestPreviousUser,bool bFilterPurple,bool bFilterSECAM,bool bFilterAverage);
	bool UpdateInputLine(short ** ppsInputBuffer,BOOL bIsOdd);	
	void RecordKeyRepeat(bool bKeyFound,int nKeyFound);
	int GetHeightBlackDynam();
	void SetHeightBlackBorder(int nHeightBlackBorder);
	void LossKeyRepeat();

protected:
	__int64 GetRDTSCTime();
	void CreateLineOrder(int clef, short *Sort);
	bool LoadFileChromi();
	bool LoadFileKey();
	void UpdateOutputLine(short ** ppsOutputBuffer);
	void UpdateOldLine();
	bool FindKeyWithMarkChromi();
	bool FindKeyWithMarkPurple();
	bool UpdatePhase();
	bool UpdateMarkChromi();
	bool UpdateMarkPurple();
	bool LoadFilePossibleNormal();
	bool LoadFileLineNormal();
	bool FindKeyNormal(int nLineIndex);
	bool FindLineNormal(int num_ligne,int * ligne_proche_dessous,int * ligne_proche_dessus);
	void CalculDiffLine(int ligne1,int ligne2);
	int CalculDiffColumn(int colonne);
	bool FindKeyWithDiff();
	void CalculColumnMask(int nb_colonne);
	void CalculInterPixelLine();
	bool LoadFilePossiblePrevious();
	bool LoadFileLinePrevious();
	bool FindKeyPrevious(int index_ligne);
	bool FindLinePrevious(int num_ligne,int nLineNotUsed,int & NumLigneDecode);
	void CalculDiffLinePrevious(int * pnLine1Current,int * pnLine2Near,int &nSumDiff,int nSumDiff_max);
	int CalculDiffColumnPrevious(int nIndexCulumn,int ValeurMax);
	void CalculInterPixelLinePrevious();
	void SetColumnSelect();
	void SetColumnOldSelect();
	void ShowColumn();		//debug
	bool IsFrameFixe();
	bool UseKeyRepeat();
	bool LoadFilePurple();
	bool DetectLineBlue(int * pnLine);
	bool DetectLineRed(int * pnLine);
	void FilterSecam(bool bPhaseFrame);
	void FilterPurple();
	void FilterAverage();	// cricri
	bool DetectLinePurple(int * pnLine);
	void FilterFrame(bool bPhaseFrame);
	void FindHeightBlackBorder();
	bool CheckFileID(FILE *sFile);

	bool	m_bKeyFound;
	bool	m_bOldKeyFound[2];
	bool	m_bPhase;
	bool	m_bInit;
	bool	m_bUsedLoadImage;
	BOOL	m_bIsOdd;
	bool	m_bKeyRepeatLock;
	bool	m_bKeyRepeatRead;
	bool	m_bFilterPurple;
	bool	m_bFilterSECAM;
	bool	m_bFilterAverage;	// cricri
	bool	m_pbVioletDetect[CURRENTY];
	bool	m_pbVioletSupprim[CURRENTY];


	int		m_nSizeBufferX;
	int		m_nSizeBufferY;
	int		m_nKeyFound;
	int		m_nHeightBlackBorder;

	int		m_nLengthTestChromi;
	int		m_nPositionTestChromi;
	int		m_nLengthTestPurple;
	int		m_nPositionTestPurple;
	
	int		m_nTypeTryPrevious;
	int		m_nTestDone;
	int		m_nLineIndexSelectPrevious;
	int		m_nTestNormalMaxi;
	int		m_nTestPreviousMaxi;
	int		m_nPositionKeyRepeat;
	int		m_nPositionKeyRepeatFound;
	int		m_nBadKeySynchrone;
	int		m_nGoodKeySynchrone;
	int		m_nBadKeySynchroneOld;
	int		m_nRateGoodProba;
	
	int		m_nProbaNormalLimitSup;
	int		m_nProbaNormalLimitInf;
	int		m_nProbaNormalDynam;

	int		m_nProbaPreviousLimitSup;
	int		m_nProbaPreviousLimitInf;
	int		m_nProbaPreviousDynam;
	int		m_nTestNormalUser;
	int		m_nTestPreviousUser;

	double	m_dInfo;
	float	m_fScrambSignalDetect;		// %
	float	m_fHeightBlackDynam;

	unsigned __int64 m_nMarkChromi;
	unsigned __int64 m_nMarkPurple;
	unsigned __int64 * m_pnArrayMaskChromi;

	short * m_psKeyMaskPurple;
	unsigned __int64 * m_pnArrayMaskPurple;


	short	m_psSortLineCurrent[CURRENTY];
	short	m_psKeyRepeat[FREQREPEATKEY];

	bool *	m_pbPossibleNormal;
	bool *	m_pbPossiblePrevious;
	short * m_psKeyMaskChromi;
	short * m_psCountKeyLineNormal;
	short * m_psCountKeyLinePrevious;
	short * m_psInterPixelNormal;	
	short * m_psInterPixelPrevious;	
	short *	m_psInterliveSort;
	short	m_psSortLineReverse[288];

	short *(* m_ppsAdressKeyLineNormal);
	short *(* m_ppsAdressKeyLinePrevious);

	int		m_pnDiffColumnNormal[NCOLUMNTESTED];
	int		m_pnDiffColumnPrevious[NCOLUMNTESTED];
	int		m_pnColumnValue[NCOLUMNTESTED][CURRENTY];
	int		m_pnColumnOldSortValue[2][NCOLUMNTESTED][CURRENTY];
	int		m_pnColumnSelect[NCOLUMNTESTED];
	int		m_pnColumnOldSelect[2][NCOLUMNTESTED];
	int *	m_pnTamponChargeCapture;
	int	*	m_pnMemoDistance;	//288*288
	int *	m_pnPositionLineNormal;
	int *	m_pnPositionLinePrevious;	
	int *	m_pnValueDiffPixelLine;
	
	int *	m_pnLineCurent288[CURRENTY];
	int *	m_pnLineSort288[CURRENTY];
	int *	m_pnLineOldSort288[2][CURRENTY];
	int *	m_pnLineNext32[OFFSET32];
	
	unsigned char * m_cKeyLine;
	unsigned char * m_pcKeyLineNormal;	
	unsigned char * m_pcKeyLinePrevious;
	char * m_pcKeyAlreadyFound;	

};

#endif
