/*************************************************************************
* autodetect.c                                                           *
* Maupatz  2001                                                          *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#include "attributes.h"
#include "mmx.h"
#include "taztv.h"
#include "nagra.h"
#include "autodetect.h"
#include "nagraudio.h"

short pixelbuffer[NBLINES][NBPIXELS];
int esperancex[NBLINES];
int covariancexy[NBLINES][NBLINES];
int ecart_type[NBLINES];
int correlation[NBLINES][NBLINES];
int x_couples[NBLINES];
int y_couples[NBLINES];
int steppixel;

/* 0=clair 1=crypt -1 ne sait pas */
int test_zone (char **lines, int zone, int width) {
   int x,y,yy,a,n;
   int plus_grand;
   float v;
   unsigned char *d;

/* precompute */

steppixel =  width / NBPIXELS;

for (y=0;y<NBLINES;y++){
      d =(unsigned char *) lines[zone + y];
      for (x=0;x<NBPIXELS;x++) {
          pixelbuffer[y][x] =  (unsigned char) *d;
          d += steppixel;
      }
 }

/* moyenne */
memset(esperancex,0,sizeof(esperancex));
for (y=0;y<NBLINES;y++){
    for (x=0;x<NBPIXELS;x++) esperancex[y]+=pixelbuffer[y][x];
     esperancex[y] /= NBPIXELS;
                       }

/* ecart_type au carr */
n=0;
memset(ecart_type,0,sizeof(ecart_type));
for (y=0;y<NBLINES;y++){
    for (x=0;x<NBPIXELS;x++){
          a = (pixelbuffer[y][x] - esperancex[y]);
          pixelbuffer[y][x]=a;
          ecart_type[y]+= a * a;
    }
    ecart_type[y] /= NBPIXELS;
    if (ecart_type[y]<SEUILUNIFORME) n++;
                        }

/* Evite les images uniformes */
if (n > (NBLINES / 2))  {
           return -1;
                        }

/* Toutes les correlations possibles */
memset(correlation,0xff,sizeof(correlation));
memset(covariancexy,0,sizeof(covariancexy));
for (y=0;y<NBLINES-1;y++) for (yy=y+1;yy<NBLINES;yy++)  {
      for (x=0;x<NBPIXELS;x++)
      covariancexy[y][yy] += pixelbuffer[y][x] * pixelbuffer[yy][x];
      covariancexy[y][yy] /= NBPIXELS;

      if ( ecart_type[yy]>SEUILUNIFORME && ecart_type[y]>SEUILUNIFORME ) {
       v = (float) covariancexy[y][yy] *  (float) covariancexy[y][yy] / (float) ecart_type[yy] / (float) ecart_type[y];
       v *= 1000000.0;
       correlation [y][yy] = v ;
      }

}

/* Reclasse les correlations */
a=0;
for (x=0;x<NBLINES - 1;x++) {
      plus_grand=-2;
      for (y=0;y<NBLINES-1;y++) for (yy=y+1;yy<NBLINES;yy++) {
      if (correlation [y][yy]!=-1)
      if (correlation [y][yy]>plus_grand){
                                          x_couples[a]=y;
                                          y_couples[a]=yy;
                                          plus_grand = correlation [y][yy];
                                         }
       }

       if (plus_grand!=-2) {
       correlation [x_couples[a]][y_couples[a]]=-1;
       a++;
}                          }

/* L'heure des comptes */
n=0;
for (y=0;y<a;y++) if ( abs(x_couples[y]-y_couples[y])<=2 ) n++;

return (n < (a / 2));

}

int autodetect (char **lines, int *flag,int width) {
      int r;
      int n0=0; /* clair  */
      int n1=0; /* crypt */

r = test_zone (lines, OZONE1,width );
if (r==0) n0++; else if (r==1) n1++;
r = test_zone (lines, OZONE2,width );
if (r==0) n0++; else if (r==1) n1++;
r = test_zone (lines, OZONE3,width );
if (r==0) n0++; else if (r==1) n1++;

if (n1>(n0+2)) *flag=1; else if (n0>(n1+2)) *flag=0;

return 0;
}


#define ASM_ALGO3 1
//#define   C_ALGO3 1

#define TESTPIXEL 64
static unsigned int BlackSet[576];
static volatile unsigned long nMaskY[2] =          { 0x00ff00ff, 0x00ff00ff };
static volatile unsigned long CurrentLowValue[2] = { 0x002d002d, 0x002d002d };

static void Black_Matrix(char **lines, int width,int height)
{
#ifdef ASM_ALGO3
 int step;
 int testpixel;

  step = (width/4); // 4 pixels at a time

  if (step/TESTPIXEL > 0)
    {
      // we test TESTPIXEL samples of 4 pixels regularly spaced and centered on the line
      step = step/TESTPIXEL;
      testpixel = TESTPIXEL;
    }
  else
    {
      // there are less of TESTPIXEL samples of 4 pixel on the line
      // test the whole line...
      testpixel = step;
      step = 1;
    }

 __asm__ __volatile__ (

// This function is defined as a macro in order to use the \@ functionnality
// which gives a different value to the @ each time it is encountered
// within the same macro.
// This allows to trick the compiler when it really inlines the function
// and therefore avoid multiple definition of hand written labels which
// would then cause a compiler failure... tricky, tricky, tricky...

".macro M_Black_Matrix\n\t"
        "movq     CurrentLowValue, %%mm5 \n\t"
        "movq     nMaskY, %%mm4          \n\t"

        "xorl     %%edx, %%edx            \n\t"
        "movl     $0, BlackSet(,%%edx,4) \n\t" // BlackSet[4*edx] = 0

        "movl     %0, %%eax              \n\t" // lines
        "movl     (%%eax,%%edx,4), %%edi \n\t" // edi = lines[0]

        "movl     %1, %%ecx              \n\t" // testpixel

        "movl     %2, %%eax              \n\t" // step
        "shrl     $1, %%eax              \n\t" // eax = step/2
        "movl     %%eax, %%esi           \n\t" // Save step/2 in esi

        "jmp      Black_Matrix.MoreToGet\\@ \n\t"

".align 16\n\t"

    "Black_Matrix.NextLine\\@:       \n\t"
        "movl     $0, BlackSet(,%%edx,4) \n\t" // BlackSet[4*edx] = 0
        "movl     %0, %%eax              \n\t" // lines
        "movl     %1, %%ecx              \n\t" // reset ecx to testpixel
        "movl     (%%eax,%%edx,4), %%edi \n\t" // edi = lines[4*edx]
        "movl     %%esi, %%eax           \n\t" // restore step/2 in eax
    "Black_Matrix.MoreToGet\\@:       \n\t"
        "movq     (%%edi, %%eax, 8), %%mm0         \n\t" // mm0 = *(edi), i.e.: mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
        "addl     %2, %%eax              \n\t" // eax += step

        "pand     %%mm4, %%mm0           \n\t" // mm0 = mm0 & nmaskY, mm0 = 00 Y3 00 Y2 00 Y1 00 Y0
        "psubusb  %%mm5, %%mm0           \n\t" // mm0 = ByteUnsignedWithSaturation( mm0 - CurrentLowValue)
                                               // i.e. mm0 = 00 Y3' 00 Y2' 00 Y1' 00 Y0'

        "packsswb %%mm0, %%mm0           \n\t" // mm0 = 00 00 00 00 Y3' Y2' Y1' Y0'

        "movd     %%mm0, %%ebx           \n\t" // ebx = Y3' Y2' Y1' Y0'
        "cmpl     $0, %%ebx              \n\t"       // if (ebx == 0)
        "jnz      Black_Matrix.NichtSchwarz\\@ \n\t" //   goto Black_Matrix.NichtSchwarz

        "loop     Black_Matrix.MoreToGet\\@ \n\t"    // ecx--; if (ecx>0) goto Black_Matrix.MoreToGet

        "movl     $1, BlackSet(,%%edx,4) \n\t"       // BlackSet[4*edx] = 1
        //"incl    AnzahlSchwarzeZeilen    \n\t"

    "Black_Matrix.NichtSchwarz\\@:       \n\t"
        "incl     %%edx                  \n\t"       // edx++
        "cmpl     %3, %%edx            \n\t"
        "jl       Black_Matrix.NextLine\\@  \n\t" //   goto Black_Matrix.NextLine

    "Black_Matrix.Ende\\@:              \n\t"
".endm\n\t"

"M_Black_Matrix\n\t"

        "emms\n\t"
        :        /* no output */
        :        /* input */
        "m" (lines),      /* %0 */
        "m" (testpixel),  /* %1 */
        "m" (step),       /* %2 */
	"m" (height)     /* %3 */
        :        /* modified regs */
        "eax", "ebx", "ecx", "edx", "edi", "esi"
        /*, "mm0", "mm1", "mm2", "mm3" */
  );
#endif

#ifdef C_ALGO3
  int i;
  int y;
  unsigned char *yuv;
  //int FirstWidth = TESTPIXEL;
  //int nPixelSchritt = width/TESTPIXEL/2;
  int testpixel;
  int step;

  step = (width/4); // 4 pixels at a time

  if (step/TESTPIXEL > 0)
    {
      // we test TESTPIXEL samples of 4 pixels regularly spaced and centered on the line
      step = step/TESTPIXEL;
      testpixel = TESTPIXEL;
    }
  else
    {
      // there are less of TESTPIXEL samples of 4 pixel on the line
      // test the whole line...
      testpixel = step;
      step = 1;
    }

  //printf("step = %d, testpixel = %d\n", step, testpixel);

  for (y=0;y<height;y++)
    {
      BlackSet[y] = 1;
      yuv = lines[y]+8*(step/2);
      for (i = 0; i < testpixel; i ++)
        {
          if (yuv[0] > 46)
            {
              BlackSet[y] = 0;
              break;
            }
          else if (yuv[2] > 46)
            {
              BlackSet[y] = 0;
              break;
            }
          else if (yuv[4] > 46)
            {
              BlackSet[y] = 0;
              break;
            }
          else if (yuv[6] > 46)
            {
              BlackSet[y] = 0;
              break;
            }

          yuv += 8*step;
        }
    }
#endif

}

int find_img_height(char **lines, int width, int height)
{
  int i;
  int m = 0;

  Black_Matrix(lines,width,height);

  for(i=0;i<height;i++)
    {
      if ( BlackSet[i] == 0) m++;
    }
  return m;
}






