#ifndef _KIZKOOL_H

#undef TUNE_SNABRAB

#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

#define U_FILTER_THRESHOLD_K25   55    // Should start at 55 %
#define V_FILTER_THRESHOLD_K25   55    // Should start at 55 %

#define U_FILTER_THRESHOLD_K28   55    // Should start at 55 %
#define V_FILTER_THRESHOLD_K28   55    // Should start at 55 %

#define U_FILTER_THRESHOLD_K30   60    // Should start at 60 %
#define V_FILTER_THRESHOLD_K30   60    // Should start at 60 %
#define YUV_FILTER_THRESHOLD_K30 40    // Should start at 40 %
#define PIX_FILTER_THRESHOLD_K30 20    // Should start at 20 %

#define U_FILTER_THRESHOLD_K31   60    // Should start at 60 %
#define V_FILTER_THRESHOLD_K31   60    // Should start at 60 %
#define YUV_FILTER_THRESHOLD_K31 40    // Should start at 40 %
#define PIX_FILTER_THRESHOLD_K31 20    // Should start at 20 %

#define U_FILTER_THRESHOLD_K32   63    // Should start at 63 %
#define V_FILTER_THRESHOLD_K32   63    // Should start at 63 %
#define YUV_FILTER_THRESHOLD_K32 43    // Should start at 43 %
#define PIX_FILTER_THRESHOLD_K32 20    // Should start at 20 %

#define U_FILTER_THRESHOLD_K32SNABRAB   63    // Should start at 63 %
#define V_FILTER_THRESHOLD_K32SNABRAB   63    // Should start at 63 %
#define YUV_FILTER_THRESHOLD_K32SNABRAB 43    // Should start at 43 %
#define PIX_FILTER_THRESHOLD_K32SNABRAB 20    // Should start at 20 %

#define U_FILTER_THRESHOLD   U_FILTER_THRESHOLD_K32
#define V_FILTER_THRESHOLD   V_FILTER_THRESHOLD_K32
#define YUV_FILTER_THRESHOLD YUV_FILTER_THRESHOLD_K32
#define PIX_FILTER_THRESHOLD PIX_FILTER_THRESHOLD_K32

#define FIRSTLINE_SNABRAB 32
#define LASTLINE_SNABRAB  52
#define THRESHOLD_SNABRAB 11

#ifndef FALSE
# define FALSE 0
#endif

#ifndef TRUE
# define TRUE !(FALSE)
#endif

#define BLUEFILTER_OFF 0

#define BLUEFILTER_K32SNABRAB 1

#define NB_KIZKOOL_FILTER 1
#define NB_BLUEFILTER  1

#define SMUDGEFILTER_OFF 0
#define SMUDGEFILTER_ON  1

struct kizkool_param_t
{
  int iPixFilterThreshold;      // for KizKoool filter >= 3.0
  int nUThreshold;              // for KizKoool filter >= 3.2
  int nVThreshold;              // for KizKoool filter >= 3.2
  int nYUVThreshold;            // for KizKoool filter >= 3.2

};
typedef struct kizkool_param_t KIZKOOL_PARAM;

struct snabrab_param_t
{
  int FirstLine;
  int LastLine;
  int Threshold;
};

typedef struct snabrab_param_t SNABRAB_PARAM;

enum {
  KIZKOOL_SMUDGE = 1,
  KIZKOOL_UTHRESHOLD,
  KIZKOOL_VTHRESHOLD,
  KIZKOOL_YUVTHRESHOLD,
  KIZKOOL_PIXFILTERTHRESHOLD,
  KIZKOOL_SNABRAB_FIRSTLINE,
  KIZKOOL_SNABRAB_LASTLINE,
  KIZKOOL_SNABRAB_THRESHOLD
};


/* For version 3.2 enhanced by snabrab */
// Public
void init_kizkool32snabrab_filter (void);
void FindFrameType32snabrab (long **pLinesAddress, unsigned short *pSortLines);
void SecamFiltering32snabrab (long **pLinesAddress, unsigned short *pSortLines);
void setfilterparam(int param, int value);
void getfilterparam(int param, int *value);
void end_kizkool32snabrab_filter (void);

// Private
#ifdef KIZKOOOL_32SNABRAB
#ifndef BYTE
# define BYTE unsigned char
#endif
static int LineSaturation (long *pQuelle, int CountX, int iLine_bugne, int iLine_sort, int Zone2_bugne);
static int NbFramesManquantes (void);
static int TestCorrectionUV (long *pQuelle, long *pSauve, long *pColorQuelle,
                 long MasqueUV);
#endif


extern int TypeImage;
extern unsigned int CurrentFrame;
extern int CurrentX;
extern int MovieScale;


#define  _KIZKOOL_H
#endif
