/*************************************************************************
* nagra.h                                                                *
* Original sources from xawdecode.  Thanks to                            *
* Gaston, kamilh, M.Kuhn, Jens, Steffen and Keuleu                       *
* Use by  Maupatz  for Taztv  2001                                       *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#ifndef NAGRA_H
#define NAGRA_H

/* Number of pixels per line on which the correlation is achieved.
   must be a multiple of 8 */
#define LD_CX_COUNT 		6
#define CX_COUNT 		32 // (2^LD_CX_COUNT)

/* Multiple of 8 */
#define NB_COUPLES_MIN 		8
#define NB_COUPLES_MAX 		80
#define NB_COUPLES_STEP   	4

/* Number of couples of lines on which the correlation is achieved. */
#define NB_COUPLES 		20


#define YSIZE  		        287
#define NB_KEYS  		32768

/* The correlation use only the lines after LINE_MIN */
#define N_LINE_MIN 		96

/* The correlation use only the lines before LINE_MAX */
#define N_LINE_MAX 		(286-96)

int decode_nagra(short *perm, char **lines, int width );
int INC_couples(void);
int DEC_couples(void);
int set_couples(int n);
int get_couples (int *n);
char *char_get_couples(void);
int init_nagra(void);
int end_nagra(void);
extern int disable_decoding;
extern int burst_phase;
extern short colortable[1380 * 4];
#endif
