/*************************************************************************
* x11.c                                                                  *
* Maupatz, Keuleu   2001                                                 *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/

#include  "taztv.h"
#include  "nagra.h"
#include  "imscaling.h"
#include  "x11.h"
#include  "video.h"
#include  "nagraudio.h"
#include  "alevt.h"
#include  "channel_gui.h"
#include  "main_gui.h"
#include  "gui.h"
#include  "i18n.h"
#include  "mixer.h"
#include  "lirc.h"

// for meuhmeuh
int toggle_meuhmeuh_filtersecam(void);
int toggle_meuhmeuh_filterpurple(void);
int toggle_meuhmeuh_filteraverage(void);
extern int plug_decoder;

#ifdef HAVE_LIBXXF86VM
# include <X11/extensions/xf86vmode.h>
# include <X11/extensions/xf86vmstr.h>
#endif

int have_vm=0;
static int fs_width=0; static int fs_height=0;
#ifdef HAVE_LIBXXF86VM
static int vm_count=0;
static XF86VidModeModeInfo **vm_modelines=NULL;
static int vm_switched=0;
#endif

#ifdef HAVE_LIBXDPMS
# include <X11/extensions/dpms.h>
# ifndef  HAVE_XV
/* XFree 3.3.x has'nt prototypes for this ... */
Bool DPMSQueryExtension (Display *, int *, int *);
Bool DPMSCapable (Display *);
Status DPMSInfo (Display *, CARD16 *, BOOL *);
Status DPMSEnable (Display *);
Status DPMSDisable (Display *);
# endif
#endif

#ifdef HAVE_XPM
#include "taztv.xpm"
# include <X11/xpm.h>
#endif
void (*PutImage) (char *dst,int w_dst, int h_dst, char **src, int w_src, int h_src,int xoffset);

Display *d;
Window w;
XEvent e;
GC gc;
XFontStruct *fd=NULL;
XGCValues gcv;
XImage *xi=NULL;
Visual *v=NULL;
char status_bar[255];
int depth;
int wrh,wrw;
int swrh,swrw;
int clear_w=0;
Window wrr;
int wxr,wyr;
int swxr,swyr;
int wbr,wdr;
int maskevent = KeyPressMask|StructureNotifyMask|ButtonPressMask|PointerMotionMask;
Atom win_stop;
Colormap cmap;
XColor sxcolor;
Cursor scursor;
Pixmap pixm;

#ifdef HAVE_XPM
  Pixmap icon_pixmap;
  Pixmap icon_shapemask;
#endif

#ifdef HAVE_XV
XvImage *xv=NULL;
Atom xvattribute;
XvImageFormatValues  *xvfo=NULL;

int       xvid=-1;
XvPortID  xvport=-1;
XvAdaptorInfo        *xvai=NULL;
XvEncodingInfo       *xvei=NULL;
XvAttribute          *xvat=NULL;
XvImageFormatValues  *xvfv=NULL;
XWindowAttributes xvwa;
int xvver, xvrel, xvreq, xvev, xverr;
int xvadaptors,xvattributes;
#endif

int user_xvport=-1;

#ifdef HAVE_MITSHM
/* Pour XShm */
int ignore, major, minor;
Bool pixmaps;
XShmSegmentInfo shminfo;
#endif

int have_xshm = 0;
int in_use=USE_XLIB;
int image_ratio=0;
int yratio=3;
int xratio=4;
int ysbar=0;
int ydbar=0;
int ratio_x=0;
int ratio_y=0;
int xwoff=0;
int ywoff=0;
int wsizew;
int wsizeh;

time_t t0,t1;
int fps=0;
int last_fps=0;

/* tag de synchro */

int tv_two_number=OFF;
int num_tv_two_number=-1;
int two_second=2;

/* Number of second to do the printing on the status bar */
int print_tag;

/* buffer de rendu */
char *rb=NULL;
int pixel_size;
int fs=0;
int mouse_hide=0;

int (*print_rb)(void);

/* Stay on top */
static int wm_detect(Display *dpy);
static void (*wm_stay_on_top)(Display *dpy, Window win, int state) = NULL;
static int state_top=0;

/***********************************************************************************/
/* Xcreate image */

int XCreate_image() {
 if (rb!=NULL) return -1;
 switch (in_use) {
        case USE_XLIB:
#ifdef HAVE_MITSHM
             if (have_xshm) {
	         xi=XShmCreateImage(d,v,depth,ZPixmap,NULL,&shminfo,wrw,wrh);
        /* Get the shared memory and check for errors */
        	shminfo.shmid = shmget(IPC_PRIVATE, xi->bytes_per_line * xi->height, IPC_CREAT |0777);
	        if (shminfo.shmid < 0) { fprintf(stderr,_("Could not allocate shared memory\n")); return -1; };

	/* attach and check for errors */
        	rb = shminfo.shmaddr = xi->data = (char *)shmat(shminfo.shmid, 0, 0);
	        if (shminfo.shmaddr == (char *)-1) { fprintf(stderr,_("Could not attached shared memory\n")); return -1; };

	/* set as read/write and attach to the display */
	        shminfo.readOnly = False;
	        if (XShmAttach(d, &shminfo)!=0) {
                                                  if (debug) fprintf(stderr, "Xshmattach Successful\n");
                                                }
                else  {
                        fprintf(stderr,_("Could not attach shared memory to display\n")); return -1;
                       }
		XSync(d,True);XSync(d,True);
                shmctl (shminfo.shmid, IPC_RMID, 0);

             }
             else  {
#endif
                     /* buffer de rendu */
                     rb = (char *) malloc(wrw*wrh*pixel_size+4);
                     if (rb==NULL) {  fprintf(stderr,_("Not enough memory rb\n")); return -1;  };
                     if (debug) fprintf(stderr,"rb ok\n");
		     xi=XCreateImage(d,v,depth,ZPixmap,0,rb,wrw,wrh,32,0);
                     if (xi==NULL){  fprintf(stderr,_("No xi\n")); return -1;  };
                     if (debug)  fprintf(stderr, "xi ok\n" );
                     XInitImage(xi);
#ifdef HAVE_MITSHM
                   }
#endif
                     break;
#ifdef HAVE_XV
        case USE_XV:
#ifdef HAVE_MITSHM
             if (have_xshm) {
                 xv = XvShmCreateImage (d,xvport,xvid,NULL,w_size,h_size,&shminfo);
                 if (xv!=NULL) if (debug)  fprintf(stderr, "xvsmh ok\n" );
        /* Get the shared memory and check for errors */
	         shminfo.shmid = shmget(IPC_PRIVATE, xv->data_size, IPC_CREAT |0777);
	         if (shminfo.shmid < 0) { fprintf(stderr,_("Could not allocate shared memory\n")); return -1; };
	/* attach and check for errors */
	         rb = shminfo.shmaddr = xv->data = (char *)shmat(shminfo.shmid, 0, 0);
	         if (shminfo.shmaddr == (char *)-1) { fprintf(stderr,_("Could not attach shared memory\n")); return -1; };

	/* set as read/write and attach to the display */
	         shminfo.readOnly = False;
	         if (XShmAttach(d, &shminfo)!=0) if (debug) fprintf(stderr, "Xshmattach Successful\n");
		 XSync(d,True);XSync(d,True);
                 shmctl (shminfo.shmid, IPC_RMID, 0);
             } else {
#endif
                     rb = (char *) malloc(w_size*h_size*2 + 4);
                     if (rb==NULL) {  fprintf(stderr,_("Not enough memory rb\n")); return -1;  };
                     if (debug) fprintf(stderr,"rb ok\n");
                     xv = XvCreateImage (d,xvport,xvid,rb,w_size,h_size);
                     if (xv!=NULL) if (debug)  fprintf(stderr, "xv ok\n" );
#ifdef HAVE_MITSHM
                    }
#endif
                    break;
#endif
 }

 return 1;
}

/* XDestroy image */
void XDestroy_image() {
 if (rb==NULL) return;
 switch (in_use) {
        case USE_XLIB:
#ifdef HAVE_MITSHM
             if (have_xshm) {
                  XShmDetach(d, &shminfo);
                  XDestroyImage(xi);
                  shmdt(shminfo.shmaddr);
		  rb=NULL;
              }
             else
#endif
             XDestroyImage(xi);
	     rb=NULL;
         break;

#ifdef HAVE_XV
  case USE_XV:
#ifdef HAVE_MITSHM
           if (have_xshm) {
                  XShmDetach(d, &shminfo);
                  XFree(xv);
                  shmdt(shminfo.shmaddr);
		  rb=NULL;
              }
               else
#endif
	     XFree(xv);
	     if (rb) { free(rb); rb=NULL; }

  break;
  #endif
 }
}

/* special 768x576 */
#ifdef HAVE_LIBXXF86VM
static void set_vidmode (int nr)
{
  XF86VidModeSwitchToMode (d, XDefaultScreen (d), vm_modelines[nr]);
  usleep(100000);
  if (debug)
    fprintf (stderr, "switching video mode to %dx%d now\n",
             vm_modelines[nr]->hdisplay, vm_modelines[nr]->vdisplay);
}
#endif

/************************************************************************************/
/*
 * Some WindowManager specific stuff
 *
 */

/* ------------------------------------------------------------------------ */

static Atom net_wm;
static Atom net_wm_state;
static Atom net_wm_top;

#define _NET_WM_STATE_REMOVE        0    /* remove/unset property */
#define _NET_WM_STATE_ADD           1    /* add/set property */

static void
net_wm_stay_on_top(Display *dpy, Window win, int state)
{
    XEvent e;

    e.xclient.type = ClientMessage;
    e.xclient.message_type = net_wm_state;
    e.xclient.display = dpy;
    e.xclient.window = win;
    e.xclient.format = 32;
    e.xclient.data.l[0] = (state == 1)
	? _NET_WM_STATE_ADD : _NET_WM_STATE_REMOVE;
    e.xclient.data.l[1] = net_wm_top;
    e.xclient.data.l[2] = 0l;
    e.xclient.data.l[3] = 0l;
    e.xclient.data.l[4] = 0l;

    XSendEvent(dpy, DefaultRootWindow(dpy), False,
	       SubstructureRedirectMask, &e);
}

/* ------------------------------------------------------------------------ */

static Atom gnome;
static Atom gnome_layer;

#define WIN_LAYER_ONBOTTOM               2
#define WIN_LAYER_NORMAL                 4
#define WIN_LAYER_ONTOP                  6

/* tested with icewm + WindowMaker */
static void
gnome_stay_on_top(Display *dpy, Window win, int state)
{
    XClientMessageEvent  xev;

    if (0 == win)
	return;

    memset(&xev, 0, sizeof(xev));
    xev.type = ClientMessage;
    xev.window = win;
    xev.message_type = gnome_layer;
    xev.format = 32;
    switch (state) {
    case -1: xev.data.l[0] = WIN_LAYER_ONBOTTOM; break;
    case  0: xev.data.l[0] = WIN_LAYER_NORMAL;   break;
    case  1: xev.data.l[0] = WIN_LAYER_ONTOP;    break;
    }
    XSendEvent(dpy,DefaultRootWindow(dpy),False,
	       SubstructureNotifyMask,(XEvent*)&xev);
    if (state)
	XRaiseWindow(dpy,win);
}

/* ------------------------------------------------------------------------ */

static int
wm_detect(Display *dpy)
{
    Atom            type;
    int             format;
    unsigned long   nitems, bytesafter;
    unsigned char  *args = NULL;
    Window root = DefaultRootWindow(dpy);

    /* build atoms */
    net_wm       = XInternAtom(dpy, "_NET_SUPPORTED", False);
    net_wm_state = XInternAtom(dpy, "_NET_WM_STATE", False);
    net_wm_top   = XInternAtom(dpy, "_NET_WM_STATE_STAYS_ON_TOP", False);
    gnome        = XInternAtom(dpy, "_WIN_SUPPORTING_WM_CHECK", False);
    gnome_layer  = XInternAtom(dpy, "_WIN_LAYER", False);

    /* gnome-compilant */
    if (Success == XGetWindowProperty
	(dpy, root, gnome, 0, (65536 / sizeof(long)), False,
	 AnyPropertyType, &type, &format, &nitems, &bytesafter, &args) &&
	nitems > 0) {
	if (debug)
	    fprintf(stderr,"wmhooks: gnome\n");
	/* FIXME: check capabilities */
	wm_stay_on_top = gnome_stay_on_top;
	XFree(args);
	return 0;
    }

    /* netwm compliant */
    if (Success == XGetWindowProperty
        (dpy, root, net_wm, 0, (65536 / sizeof(long)), False,
         AnyPropertyType, &type, &format, &nitems, &bytesafter, &args) &&
	nitems > 0) {
	if (debug)
	    fprintf(stderr,"wmhooks: netwm\n");
	wm_stay_on_top = net_wm_stay_on_top;
        XFree(args);
        return 0;
    }

    /* nothing found... */
    return -1;
}

/**********************************************************************************/

static int xtext, ytext;
static int oxtext,oytext;
static unsigned char *text_b=NULL;


static void convert_rgb_to_yuy2 (unsigned char *yuy2, unsigned char *rgb) {

           int r0=0,r1=0,g0=0,g1=0,b0=0,b1=0;

           switch (depth) {
                case 24: case 32:
                        r0=*(rgb+2);g0=*(rgb+1);b0=*rgb;
                        r1=*(rgb+6);g1=*(rgb+5);b1=*(rgb+4);
                break;

                case 16:
                       r0= (*rgb) + (*(rgb+1)<<8);
		       g0=(r0 & 0x07e0)>>3;
		       b0=(r0 & 0x001f)<<3;
                       r0=(r0 & 0xf800)>>8;
                       r1=(*(rgb+2)) + (*(rgb+3)<<8);
		       g1=(r1 & 0x07e0)>>3;
		       b1=(r1 & 0x001f)<<3;
                       r1=(r1 & 0xf800)>>8;
                break;

                case 15:
                       r0=(*rgb) + (*(rgb+1)<<8);
		       g0=(r0 & 0x03e0)>>2;
		       b0=(r0 & 0x001f)<<3;
                       r0=(r0 & 0x7c00)>>7;
                       r1=(*(rgb+2)) + (*(rgb+3)<<8);
		       g1=(r1 & 0x07e0)>>2;
		       b1=(r1 & 0x001f)<<3;
                       r1=(r1 & 0x7c00)>>7;
                break;

           }

           *(yuy2)=   0.257*(float)r0 + 0.504*(float)g0 + 0.098*(float)b0 + 16.0;
           *(yuy2+2)= 0.257*(float)r1 + 0.504*(float)g1 + 0.098*(float)b1 + 16.0;

	    r0=(r0+r1)/2;g0=(g0+g1)/2; g0=(g0+g1)/2;

           *(yuy2+1)=-0.148*(float)r0 - 0.368*(float)g0 + 0.469*(float)b0 + 128.0;
	   *(yuy2+3)= 0.439*(float)r0 - 0.368*(float)g0 - 0.071*(float)b0 + 128.0;
}


inline  void display_fps(void)
{
    int j=0;

    if (print_tag && fs) {
       if (in_use==USE_XV) {
       for (j=0; j<ytext; j++)
                               memcpy (rb + oxtext * 2 + (j+oytext)*w_size*2 ,
                                       text_b + j * xtext * 2,
                                       xtext * 2);

     } else {
               for (j=0; j<ytext; j++)
                               memcpy (rb + oxtext * pixel_size + (j+oytext)*wrw*pixel_size ,
                                       text_b + j * xtext * pixel_size,
                                       xtext * pixel_size);
            }

     }

     fps++;
     t1=time(NULL);

     if (t1>t0) {
                  if (fs && !mouse_hide) {
                            XDefineCursor(d,w,scursor);
                            mouse_hide=1;
                  }
                  two_second --;
                  if (two_second==0) {
                                       two_second=2;
                                       num_tv_two_number=-1;
                                     };
                  if (print_tag!=0)  print_tag--;
                     else {
                            if (!fs) {
                                       sprintf(status_bar,"Taztv : %s : %d fps",get_current_tv_channel(NULL),fps);
                                       XStoreName(d,w,status_bar);
                                      }
                            if (text_b) {  free(text_b); text_b=NULL; }
                          }
                             last_fps=fps;
                             fps=0;
                             t0=t1;
                 }

}

/**********************************Print status ***********************************/

/* ratio optimisation */
void setbar() {
         ysbar=((float)H - (float) yratio / (float) xratio * (float) W) / 2.0 * (float) h_size / (float) H;
         ydbar = (float) ysbar  * (float)(wrh) / (float) h_size;
	 if (ysbar<0) ysbar=0;
         if (ydbar<0) ydbar=0;
	 if (ysbar>(h_size/4)) ysbar=h_size/4;
	 if (ydbar>(wrh/4)) ydbar=wrh/4;
         clear_w=1;
         // printf("set bar s=%d d=%d\n",ysbar,ydbar);
}

void set_win_ratio(int *width, int *height, int *xoff, int *yoff)
{
    int h = *height;
    int w = *width;

    if (0 == ratio_x || 0 == ratio_y) return;

    *yoff=0;*xoff=0;

    if (w * ratio_y < h * ratio_x)
    {
	*height = (*width * ratio_y / ratio_x);
	*yoff   = ((h-*height)/2);
	*height &= 0xfffffffc;
        *yoff   &= 0xfffffffc;
    }
    else
    if (w * ratio_y > h * ratio_x)
    {
	*width  = (*height * ratio_x / ratio_y);
	*xoff   = ((w-*width)/2);
        *width &= 0xfffffffc;
        *xoff  &= 0xfffffffc;
    }
}


int set_win_format_ratio (int rx,int ry)
{
 ratio_x=rx; ratio_y=ry;
 if (debug) printf("Set format ratio to %d/%d\n",ratio_x,ratio_y);
 return 0;
}

int set_img_format_ratio (int image_ratio)
{
 switch (image_ratio)
 {
  case 1 : set_img_format (16,9); break;
  case 2 : set_img_format (20,9); break;

  default : set_img_format (4,3); break;
 }
 return image_ratio;
}

int set_img_format  (int rx,int ry)
{
  yratio=ry; xratio=rx;
  setbar();
  return 0;
}

char *get_char_format_ratio(void)
{
  switch (image_ratio) {
                   case 3:
                         return "Auto";
                   break;
	           case 0:
                         return "4/3";
                   break;

		   case 1:
                         return "16/9";
                   break;

		   case 2:
                         return "20/9";
                   break;
  }
 return "Not supported";
}

int setimagesize (int x,int y)
{ 
  int r;

  wrw = x&0xfffffffc;
  wrh = y&0xfffffffc;
  set_win_ratio(&wrw, &wrh,&xwoff, &ywoff);
  // {static int c__i;c__i++;printf ("%d %d %d : %d %d : %d %d \n",c__i,x,y,wrw,wrh,xwoff,ywoff);}
  r=setcapturesize(wrw,wrh);
  if (wrh<=HT)  set_fast_quality_mode (ON); else  set_fast_quality_mode (OFF);
  return r;
}

int print_status_bar(char *s){
    Pixmap pix_text;
    XImage *text_img=NULL;
    int i=0; int j=0;

    if (!fs) { XStoreName(d,w,s); }
       else
           {
             if (s!=status_bar) strcpy(status_bar,s);
             xtext = fd->max_bounds.width * strlen(status_bar);
             if (xtext&1) xtext++;
             ytext = fd->max_bounds.ascent + fd->max_bounds.descent;
             if (in_use==USE_XV) oxtext = (w_size - xtext)/2; else  oxtext = (wrw - xtext)/2;
             if (oxtext&1) oxtext++;

              if (in_use==USE_XV) oytext=ysbar+10; else oytext=ydbar+10;

             pix_text=XCreatePixmap(d,RootWindow(d,DefaultScreen(d)),xtext,ytext,depth);
             XDrawImageString (d,pix_text,gc,0,ytext - fd->max_bounds.descent,status_bar,strlen(status_bar));
             text_img = XGetImage(d,pix_text, 0,0,xtext,ytext,0xffffffff,ZPixmap);

             if (text_b) {  free(text_b); text_b=NULL; }

             if (in_use==USE_XV) {
                 text_b = (unsigned char *) malloc (xtext*ytext*2);

                  for (j=0; j<ytext; j++) {
                      for (i=0; i<(xtext-1); i+=2) {
                            convert_rgb_to_yuy2 ( text_b + i * 2 + j * xtext * 2,
                                                  text_img->data + i * pixel_size + j * pixel_size * xtext
	                                        );
                                                   }
                                          }


             } else {
                     text_b = (unsigned char *) malloc (xtext*ytext*pixel_size);
                     memcpy(text_b,text_img->data,xtext*ytext*pixel_size);
                    }

             XDestroyImage(text_img);
             XFreePixmap(d,pix_text);
          }
    print_tag=2;
    return 0;
}


inline int print_rb_xvshm(void){
  int i=0,s=w_size*h_size*2;

  display_fps();
  XLockDisplay(d);
#ifdef HAVE_MITSHM
#ifdef HAVE_XV
  if (clear_w) {
                 clear_w=0;
		 for (i=0;i<s;i+=4){
		                     rb[i]=0x10;rb[i+1]=0x80;rb[i+2]=0x10;rb[i+3]=0x80;
				   }
                 XvShmPutImage(d,xvport,w,gc,xv,0,0,w_size,h_size,0,0,wrw,wrh,False);
  } else
  XvShmPutImage(d,xvport,w,gc,xv,0,0 + ysbar,w_size,h_size-2*ysbar,0+xwoff,0+ydbar+ywoff,wrw,wrh-2*ydbar,False);
#endif
#endif
  XUnlockDisplay(d);
  return 0;
}

inline int print_rb_xv(void){
  int i=0,s=w_size*h_size*2;

  display_fps();

  XLockDisplay(d);
#ifdef HAVE_XV
   if (clear_w) {
                 clear_w=0;
		 for (i=0;i<s;i+=4){
		                     rb[i]=0x10;rb[i+1]=0x80;rb[i+2]=0x10;rb[i+3]=0x80;
				   }
                 XvPutImage(d,xvport,w,gc,xv,0,0,w_size,h_size,0,0,wrw,wrh);
  } else
  XvPutImage(d,xvport,w,gc,xv,0,0+ysbar,w_size,h_size-2*ysbar,0+xwoff,0+ydbar+ywoff,wrw,wrh-2*ydbar);
#endif
  XUnlockDisplay(d);
  return 0;
}

inline int print_rb_xshm(void){

  display_fps();

  XLockDisplay(d);
#ifdef HAVE_MITSHM
  if (clear_w)
  {
   clear_w=0;
   memset (rb,0,wrw*wrh*pixel_size);
   XShmPutImage (d,w,gc,xi,0,0,0,0,wrw,wrh,False);
  } else
  XShmPutImage (d,w,gc,xi,0,0+ydbar,0+xwoff,0+ydbar+ywoff,wrw,wrh-2*ydbar,False);
#endif
  XUnlockDisplay(d);

  return 0;
}

inline int print_rb_x(void){

  display_fps();

  XLockDisplay(d);
  if (clear_w)
  {
   clear_w=0;
   memset (rb,0,wrw*wrh*pixel_size);
   XPutImage (d,w,gc,xi,0,0,0,0,wrw,wrh);
  } else
  XPutImage (d,w,gc,xi,0,0+ydbar,0+xwoff,0+ydbar+ywoff,wrw,wrh-2*ydbar);
  XUnlockDisplay(d);

  return 0;
}

int set_fullscreen (int x,int y)
{
 fs_width=x;
 fs_height=y;
 if (debug) printf ("Fullscreen set to %dx%d\n",fs_width,fs_height);
 return 0;
}


/***********************************************************************************/

int init_x11() {

int val,i,j;
int find_xvsetdefaults=0;
XWMHints *IconXWM;

/* X */
 XInitThreads();

if ((d = XOpenDisplay(getenv("DISPLAY")))==NULL){
    fprintf(stderr,_("can't open display\n"));
    return -1;
}

#ifdef HAVE_LIBXXF86VM
if (!disable_vm) {
  if (XF86VidModeQueryExtension (d, &i, &j))
    {
      int mi,ma;
      XF86VidModeQueryVersion (d, &ma, &mi);
      if (debug) fprintf (stderr, "VidMode: server=%d.%d, include=%d.%d\n",
               ma, mi, XF86VIDMODE_MAJOR_VERSION, XF86VIDMODE_MINOR_VERSION);
      if ((ma != XF86VIDMODE_MAJOR_VERSION)
          || (mi != XF86VIDMODE_MINOR_VERSION))
        { if (debug) fprintf (stderr, "VidMode: version mismatch -- disabled\n"); }
      else
        {
          have_vm = 1;
          if (debug) fprintf (stderr, "  available video mode(s):");
          XF86VidModeGetAllModeLines (d, XDefaultScreen (d),
                                      &vm_count, &vm_modelines);
          for (i = 0; i < vm_count; i++)
            {
              if (debug) fprintf (stderr, " %dx%d",
                       vm_modelines[i]->hdisplay, vm_modelines[i]->vdisplay);
            }
          if (debug) fprintf (stderr, "\n");
	  XFree(vm_modelines); vm_count=0;vm_modelines=NULL;
        }
    }
  } else
  {
   if (debug) fprintf (stderr, "VidMode: disabled\n");
   have_vm=0;
  }
#endif

#ifdef HAVE_MITSHM
/* Check for the XShm extension */
if (!disable_xshm) {
if (XQueryExtension(d, "MIT-SHM", &ignore, &ignore, &ignore))
  {
    if(XShmQueryVersion(d, &major, &minor, &pixmaps) == True)
	  {
	    if (debug)
	    fprintf(stderr,"XShm extension version %d.%d %s shared pixmaps\n", major, minor, (pixmaps==True)?"with":"without");
		have_xshm = 1;
	  }
	else
	  {
        if (debug) fprintf(stderr,"XShm not available\n");
		have_xshm = 0;
	  }
  }
else
  {
	if (debug) fprintf(stderr,"XShm not available\n");
  }
                 }
#endif

#ifdef HAVE_XV
    /* query+print Xvideo properties */
if (!disable_xv) {
if (Success != XvQueryExtension(d,&xvver,&xvrel,&xvreq,&xvev,&xverr))
 {
	if (debug) fprintf(stderr,"Server does'nt support Xvideo \n");
        in_use=USE_XLIB;
 } else

if (Success != XvQueryAdaptors(d,DefaultRootWindow(d),&xvadaptors,&xvai))
{
	if (debug) fprintf(stderr,"XvQueryAdaptors failed \n");
	in_use=USE_XLIB;
}
else
{
 if (debug) fprintf(stderr,"%d adaptors available.\n",xvadaptors);
 if (debug) if (user_xvport!=-1) fprintf(stderr,"User want to use Xvideo port %d\n",user_xvport);

 for (i = 0; (i < xvadaptors) && (xvport==-1); i++)
 {
    int k,l,n;

    if (debug) fprintf(stderr,"  name:  %s\n",xvai[i].name);
    for (j=0;j<xvai[i].num_formats;j++) if (debug)
    fprintf(stderr,"Format %d = depth:%d id:%x\n",j,xvai[i].formats[j].depth,(int) xvai[i].formats[j].visual_id);

    if (!((xvai[i].type & XvInputMask) && (xvai[i].type & XvImageMask)))
    {
     if ((user_xvport!=-1) && (user_xvport>=xvai[i].base_id)
        && (user_xvport<(xvai[i].base_id+xvai[i].num_ports)))
     {
       fprintf (stderr, "Selected xvideo port %d can't do Putimage : exiting\n",user_xvport);
       if (xvadaptors>0) XvFreeAdaptorInfo(xvai);
       return -1;
     }
     continue;
    }

    if (user_xvport!=-1)
    {
      if (user_xvport<xvai[i].base_id) continue;
      if (user_xvport>=(xvai[i].base_id+xvai[i].num_ports)) continue;
      xvfo = XvListImageFormats(d, user_xvport,&n);
      if (debug) fprintf(stderr,"%d Image format\n",n);

      for(k = 0; k < n; k++)
      {
       if (debug) fprintf(stderr,"Find user select port %d : %4s\n",user_xvport,(char *) &xvfo[k].id);
       if (xvfo[k].id == YUY2)
       {
        xvid=xvfo[k].id;
        if (debug) fprintf(stderr,"Can do YUY2 very good !!!\n");
       }
      }
      if (xvfo!=NULL) XFree(xvfo);

      if (xvid!=-1)
      {
         if (XvGrabPort (d, user_xvport, CurrentTime) == Success)
         {
	   xvport=user_xvport;
           if (debug) fprintf (stderr, "Selected Xvport number %d\n",user_xvport );
           break;
         }
         else
         {
           xvid=-1;
           fprintf (stderr, "Xvideo port %d in use by an other application : exiting\n",user_xvport);
	   if (xvadaptors>0) XvFreeAdaptorInfo(xvai);
           return -1;
         }
      }
      else
      {
       fprintf (stderr, "This port %d can't do YUY2 : exiting\n",user_xvport);
       if (xvadaptors>0) XvFreeAdaptorInfo(xvai);
       return -1;
      }
     }

    /* scan port */
    for (l=xvai[i].base_id;l<(xvai[i].base_id+xvai[i].num_ports);l++)
    {
     if (debug) fprintf(stderr,"Try port %d\n",l);
     xvfo = XvListImageFormats(d,l,&n);
     if (debug) fprintf(stderr,"%d Image format\n",n);

     for(k = 0; k < n; k++)
     {
       if (debug) fprintf(stderr,"Find : %4s\n",(char *) &xvfo[k].id);
       if (xvfo[k].id == YUY2)
       {
        xvid=xvfo[k].id;
        if (debug) fprintf(stderr,"Can do YUY2 very good !!!\n");
       }
     }
     if (xvfo!=NULL) XFree(xvfo);
     if (xvid!=-1)
     {
         if (XvGrabPort (d,l, CurrentTime) == Success)
         {
	   xvport=l;
           if (debug) fprintf (stderr, "Selected Xvport number %ld\n",xvport);
           break;
         } else { xvid=-1; if (debug) fprintf(stderr,"Port %d is busy\n",l);}
      }
     }
 } /* end for i*/

if (xvadaptors>0) XvFreeAdaptorInfo(xvai);

 /* si Pas YUY2 */
 if (xvid==-1)
 {

  if (user_xvport!=-1)
  {
   fprintf(stderr,"No Selected Xv port available :((\n");
   return -1;
  }
  if (debug) fprintf(stderr,"Can't find a YUY2 port : Use XLIB :( \n"  );
  in_use=USE_XLIB;
 }
 else
 {
  in_use=USE_XV;

  xvat = XvQueryPortAttributes(d, xvport, &i);
  if (xvat!=NULL){
  if (debug) fprintf(stderr," %d Attributes\n",i);

  /* Try to find XV_SET_DEFAULTS */
  for (j=0;j<i;j++)
  {
    if (strcmp("XV_SET_DEFAULTS",xvat[j].name)==0)
    {
            xvattribute=XInternAtom(d,xvat[j].name,True);
	    /* Assume max_value is a good value */
            val = xvat[j].max_value;
            XvSetPortAttribute(d,xvport,xvattribute,val);
            if (debug) fprintf(stderr,"Set automaticaly Xv to Defaults Values\n");
	    find_xvsetdefaults=1;
    }
  }

  /* Special case of Overlaykey */

 /* Desactive XV_AUTOPAINT_COLORKEY */
  for (j=0;j<i;j++)
  {
    if (strcmp("XV_AUTOPAINT_COLORKEY",xvat[j].name)==0)
    {
            xvattribute=XInternAtom(d,xvat[j].name,True);
	    /* Desactive this */
            val = 0;
            XvSetPortAttribute(d,xvport,xvattribute,val);
            if (debug) fprintf(stderr,"Set XV_AUTOPAINT_COLORKEY to 0\n");
    }
  }

 /* Xvcolorkey set to 0 */
  for (j=0;j<i;j++)
  {
   if (strcmp("XV_COLORKEY",xvat[j].name)==0)
   {
            xvattribute=XInternAtom(d,xvat[j].name,True);
            val=0;
            XvSetPortAttribute(d,xvport,xvattribute,val);
            if (debug) fprintf(stderr,"%s set to %d\n",xvat[j].name,val);
   }
  }

  /* Manually set*/
  if (!find_xvsetdefaults)
  {
  if (debug) fprintf(stderr,"Set manualy Xv to Defaults Values\n");
  for (j=0;j<i;j++)
  {

   if (xvat[j].flags & XvGettable)  if (debug)
   fprintf(stderr,"XvGettable : %s : min %d : max %d \n",xvat[j].name,xvat[j].min_value,
                 xvat[j].max_value);

   if (xvat[j].flags & XvSettable) if (debug)
   fprintf(stderr,"XvSettable : %s : min %d : max %d \n",xvat[j].name,xvat[j].min_value,
                 xvat[j].max_value);

   if (strcmp("XV_BRIGHTNESS",xvat[j].name)==0){
            xvattribute=XInternAtom(d,xvat[j].name,True);
            val =(xvat[j].min_value + xvat[j].max_value) / 2;
            XvSetPortAttribute(d,xvport,xvattribute,val);
            if (debug) fprintf(stderr,"%s set to %d\n",xvat[j].name,val);
                                               }

   if (strcmp("XV_CONTRAST",xvat[j].name)==0){
            xvattribute=XInternAtom(d,xvat[j].name,True);
            val =(xvat[j].min_value + xvat[j].max_value) / 2;
            XvSetPortAttribute(d,xvport,xvattribute,val);
            if (debug) fprintf(stderr,"%s set to %d\n",xvat[j].name,val);
                                             }

    if (strcmp("XV_SATURATION",xvat[j].name)==0){
            xvattribute=XInternAtom(d,xvat[j].name,True);
            val =(xvat[j].min_value + xvat[j].max_value) / 2;
            XvSetPortAttribute(d,xvport,xvattribute,val);
            if (debug) fprintf(stderr,"%s set to %d\n",xvat[j].name,val);
                                                }

    if (strcmp("XV_HUE",xvat[j].name)==0){
            xvattribute=XInternAtom(d,xvat[j].name,True);
	    /* ATI -1000 to 1000; Nvidia 0..360 in degrees?*/
            /*Fixme: assume 0 is good ?*/
            val=0;
	    XvSetPortAttribute(d,xvport,xvattribute,val);
            if (debug) fprintf(stderr,"%s set to %d\n",xvat[j].name,val);
                                         }

   }
   }
                  }
                     }
        }
                  }
#endif

if (disable_xshm) have_xshm=0;
if (disable_xv) in_use=USE_XLIB;

wsizeh=wrh=H/2;
wsizew=wrw=W/2;

depth = DisplayPlanes(d,DefaultScreen(d));

switch (depth) {
                case 24: case 32:
                     PutImage = PutImageRGB32;
                     pixel_size = 4;
                break;

                case 16:
                      PutImage = PutImageRGB16;
                      pixel_size = 2;
                break;

                case 15:
                      PutImage = PutImageRGB15;
                      pixel_size = 2;
                break;

                default:
                pixel_size = 2;
                if (in_use!=USE_XV) {
                  fprintf(stderr,"Not supported this Depth: %d\n",depth);
                  fprintf(stderr,"Must be 15,16,24,32 \n");
                  return -1;
                }
                break;
}

if (debug) fprintf(stderr,"Depth %d\n",depth);

win_stop = XInternAtom(d, "WM_DELETE_WINDOW", False);

w = XCreateSimpleWindow(d,RootWindow(d,DefaultScreen(d)),
                        0,0,wsizew,wsizeh,
                        depth,BlackPixel(d,DefaultScreen(d)),
                        BlackPixel(d,DefaultScreen(d)));

XSetWMProtocols(d, w, &win_stop, 1);

v=DefaultVisual(d,DefaultScreen(d));

XStoreName(d,w,PACKAGE_STRING);
print_tag=3;

if ((fd=XLoadQueryFont(d,"-Xxl-LedFixed-Medium-R-SemiCondensed--39-120-75-75-C-180-ISO8859-1"))==NULL){
  if ((fd=XLoadQueryFont(d,"fixed"))==NULL) {
    fprintf(stderr,_("Can't load police fixed\n"));
    return -1;
  }
}

gcv.font=fd->fid;
gcv.graphics_exposures = False;
gcv.background = BlackPixel(d,DefaultScreen(d));
cmap = DefaultColormap(d,DefaultScreen(d));
sxcolor.red=0xffff;
sxcolor.green=0;
sxcolor.blue=0;
if (XAllocColor(d,cmap,&sxcolor)==0)
                   gcv.foreground = WhitePixel(d,DefaultScreen(d));
    else
                   gcv.foreground = sxcolor.pixel;

gcv.function = GXcopy;
gc = XCreateGC(d,w,GCFont | GCForeground | GCBackground  | GCGraphicsExposures | GCFunction,&gcv);

XSelectInput(d,w,maskevent);

/* cursor noir */
sxcolor.red=0;
sxcolor.green=0;
sxcolor.blue=0;
XAllocColor(d,cmap,&sxcolor);
pixm = XCreatePixmap( d,DefaultRootWindow(d),1, 1, 1 );
scursor = XCreatePixmapCursor(d,pixm, pixm, &sxcolor, &sxcolor, 1, 1 );

if (setimagesize(wsizew,wsizeh)==-1) return -1;

 switch (in_use)
   {
   case USE_XV:
     if (have_xshm)
       {
	 print_rb = print_rb_xvshm;
	   if (debug)
	     fprintf(stderr,"Use XvShm\n");
       }
     else
       {
	 print_rb = print_rb_xv;
	 if (debug)
	   fprintf(stderr,"Use Xv\n");
       }
     break;

   case USE_XLIB:
     if (have_xshm)
       {
	 print_rb = print_rb_xshm;
	 if (debug)
	   fprintf(stderr,"Use XShm\n");
       }
     else
       {
	 print_rb = print_rb_x;
	 if (debug)
	   fprintf(stderr,"Use Xlib\n");
       }
     break;
   }

/* map window */
XMapWindow(d,w);
XSync(d,True);
XSync(d,True);
XSync(d,True);
XSync(d,True);

/**** alevt init ****/
init_alevt (d);

/**** gui init ****/
init_gui(d,w);

/***** lirc ****/
lirc_tv_init ();

#ifdef HAVE_XPM
XpmCreatePixmapFromData(d,w,taztv_xpm,&icon_pixmap,&icon_shapemask, NULL);
IconXWM=XAllocWMHints();
IconXWM->flags=IconPixmapHint | IconMaskHint;
IconXWM->icon_pixmap=icon_pixmap;
IconXWM->icon_mask=icon_shapemask;
XSetWMHints(d,w,IconXWM);
XFree(IconXWM);
#endif

wm_detect(d);

fps=0;
t0=time(NULL);

return 0;

}   /* end de init */


/***********************************************************************************/
 void set_keypad_channel( int n) {
     if (tv_two_number)  {
     if (num_tv_two_number==-1) {
                                  num_tv_two_number=n * 10;
                                  sprintf(status_bar,"%d_",n);
                                              print_status_bar(status_bar);
                                              two_second=2;
                                              return;
                                 } else num_tv_two_number+=n;
                        } else  num_tv_two_number=n;
    if (num_tv_two_number==0) return;
    sprintf(status_bar,"%d : %s", num_tv_two_number,set_tv_channel_by_number(num_tv_two_number));
    print_status_bar(status_bar);
    num_tv_two_number=-1;
 }

int get_number_mode(void)
{
  return tv_two_number;
}


int processevent(){

    if (norm_changed) {
                       norm_changed=0;
                       setimagesize(wsizew,wsizeh);
                     }

    lirc_tv_havedata();

    if (XPending(d)==0) return 0;

    while (XCheckWindowEvent (d,w,maskevent,&e)!=False){

    // printf ("Event type : %d \n",e.type);

     switch(e.type){

     case MotionNotify:
          if (!fs) break;
          if (mouse_hide) {
                            XUndefineCursor(d,w);
                            mouse_hide=0;
          }
     break;

     case ButtonPress:

          abort_channel_list_gui();

          // Gestion GUI
          // printf("button %d \n",e.xbutton.button);
          // 1 boutton  gauche
          // 2 boutton  centre
          // 3 boutton  droit
          // 4 Molette up
          // 5 Molette down
          switch  (e.xbutton.button){
                  case 1:
                   // printf("Pointer x y : %d %d \n",e.xbutton.x,e.xbutton.y);

                   XTranslateCoordinates(d,w,RootWindow(d,DefaultScreen(d)),
                                 e.xbutton.x,e.xbutton.y ,&swxr,&swyr,&wrr);

                 // printf("Translate x y : %d %d \n",swxr,swyr);

                  pop_channel_list_gui(swxr,swyr);

                  break;

                  case 2:
                       toggle_alevt();
                  break;

                  case 3:
                       toggle_main_gui();
                  break;

                  case 4:
                       sprintf(status_bar,"%s",inc_tv_channel());
                       print_status_bar(status_bar);
                  break;

                  case 5:
                       sprintf(status_bar,"%s",dec_tv_channel());
                       print_status_bar(status_bar);
                  break;
          }
     break;

     case ConfigureNotify:
          abort_channel_list_gui();
	  if(   (wsizew) == (e.xconfigure.width  & 0xfffffffc)
             && (wsizeh) == (e.xconfigure.height & 0xfffffffc) ) break;
           wsizew = e.xconfigure.width  & 0xfffffffc;
           wsizeh = e.xconfigure.height & 0xfffffffc;
	   setimagesize (wsizew,wsizeh);
     break;

     case KeyPress:

         abort_channel_list_gui();

      switch (XLookupKeysym((XKeyEvent *) &e,0)) {
              case XK_C: case XK_c:
	       image_ratio++;
	       if (image_ratio>=4) image_ratio=0;
               set_img_format_ratio (image_ratio);
               print_status_bar(get_char_format_ratio());
	      break;

              case XK_D: case XK_d:
                switch (toggle_decoder_mode ()){
                  default:
                           if (synchro_sound_video)
                           print_status_bar("Decoder & sound not active");
                           else
                           print_status_bar(N_("Decoder inactived"));
                   break;
                   case OFF:
                           if (synchro_sound_video)
                           print_status_bar("Decoder & sound off");
                           else
                           print_status_bar(_("Decoder off"));
                   break;
                   case ON:
                           if (synchro_sound_video)
                           print_status_bar("Decoder & sound on");
                           else
                           print_status_bar(_("Decoder on"));
                   break;
                   case AUTO:
                           if (synchro_sound_video)
                           print_status_bar("Decoder & sound auto");
                           else
                           print_status_bar(_("Decoder auto"));
                   break;
                }
              break;

              case XK_I: case XK_i:
                switch (toggle_quality_mode()){
                    case OFF:
                      print_status_bar(_("High quality off"));
                    break;

                    case ON:
                      print_status_bar(_("High quality on"));
                    break;
                  }
              break;

              case XK_N: case XK_n:
                if (plug_decoder!=0) break;
                switch (toggle_filter_mode()){
                                case OFF:
                                     print_status_bar(_("Filter off"));
                                break;
                                case ON:
                                     print_status_bar(_("Filter on"));
                                break;
               }
              break;

              case XK_m: case XK_M: case XK_KP_Enter:
                  switch (toggle_mute_sound()) {
                         case ON:
                            print_status_bar(_("Sound Mute"));
                         break;

                         case OFF:
                            print_status_bar(_("Sound UnMute"));
                         break;

                         default:
                            print_status_bar(_("Can't Mute : use mixer"));
                         break;
                  }
              break;

              case XK_t: case XK_T:
	            if (wm_stay_on_top)
		    {
	             state_top = !state_top;
                     wm_stay_on_top (d,w,state_top);
                      switch (state_top) {
                         case 0:
                            print_status_bar("Stay on top inactive");
                         break;

                         case 1:
                            print_status_bar("Stay on top active");
                         break;
                      }
		    }
	      break;

              case XK_s: case XK_S:
                      if (synchro_sound_video) { print_status_bar("SYNCHRO : use D instead"); break; }

                      switch (toggle_sound_decoder_mode()) {

                         case OFF:
                                   print_status_bar(_("Sound decoder off"));
                         break;

                         case ON:
                                   print_status_bar(_("Sound decoder on"));
                         break;


                         case AUTO:
                                   print_status_bar(_("Sound decoder auto"));
                         break;
                      }
              break;

             case XK_F: case XK_f:
               {
#ifdef HAVE_LIBXDPMS
                 static BOOL dpms_on;
                 CARD16 dpms_state;
                 int dpms_dummy;
#endif


                 static int timeout, interval, prefer_blanking, allow_exposures;
        if (!have_vm)
	{
         fs_width=XDisplayWidth(d,DefaultScreen(d));
         fs_height=XDisplayHeight(d,DefaultScreen(d));
        }
	 else
        {
         if (fs_width ==0) fs_width =W;
         if (fs_height==0) fs_height=H;
	}

#ifdef HAVE_LIBXXF86VM
      if (fs && have_vm && vm_switched)
        {
          set_vidmode (0);
          vm_switched = 0;
          if (vm_modelines) { XFree(vm_modelines); vm_count=0;vm_modelines=NULL; }
        }

      if (!fs && have_vm)
        {
          int i;

          XF86VidModeGetAllModeLines (d, XDefaultScreen (d),&vm_count, &vm_modelines);
          for (i = 0; i < vm_count; i++)
            if (fs_width == vm_modelines[i]->hdisplay &&
                fs_height == vm_modelines[i]->vdisplay)
              break;

          if (i != 0 && i != vm_count)
            {
              set_vidmode (i);
              vm_switched = 1;
              fs_width = vm_modelines[i]->hdisplay;
              fs_height = vm_modelines[i]->vdisplay;
            }
          else
            {
              vm_switched = 0;
              fs_width = vm_modelines[0]->hdisplay;
              fs_height = vm_modelines[0]->vdisplay;
              if (vm_modelines) { XFree(vm_modelines); vm_count=0;vm_modelines=NULL; }
            }

          XF86VidModeSetViewPort (d, XDefaultScreen (d), 0, 0);

          if (debug)
            fprintf (stderr, "viewport: %dx%d\n", fs_width, fs_height);
        }
#endif
               fs=!fs;
               if (fs) {

                        XGetGeometry(d,w,&wrr,&wxr,&wyr,&swrw,&swrh,&wbr,&wdr);
                        XTranslateCoordinates(d,w,RootWindow(d,DefaultScreen(d)),
                                 -wxr,-wyr,&swxr,&swyr,&wrr);
                        /* wxr et wyr ne doivent pas tre gal  zro     */
                        /* Pour les wms   rcalcitrants genre kde 2.1     */

                        if (wxr==0 && wyr==0)
			{
			     XLockDisplay(d);
			     XMoveWindow(d,w,0,1);XSync(d,True);XSync(d,True);XSync(d,True);
			     XMoveWindow(d,w,0,0);usleep(100000);XSync(d,True);XSync(d,True);
                             XUnlockDisplay(d);

                             XTranslateCoordinates(d,w,RootWindow(d,DefaultScreen(d)),0,0,&wxr,&wyr,&wrr);

                             swxr-=wxr; swyr-=wyr;

                             if ( swyr<=0 ) { /* Petit hack kde 2.1 */
                                               if (wyr!=0)  swyr = wyr ;
                                               else  swyr = XDisplayHeight(d,DefaultScreen(d)) / 4 ;
                                            }

                        }

                        XMoveResizeWindow(d, w, -wxr,-wyr,fs_width,fs_height );
			XSync(d,True); XSync(d,True);XSync(d,True); XSync(d,True);
                        XGetScreenSaver (d, &timeout, &interval,&prefer_blanking, &allow_exposures);
                        XSetScreenSaver (d, 0, 0, DefaultBlanking, DefaultExposures);

#ifdef HAVE_LIBXDPMS
                        if ((DPMSQueryExtension (d, &dpms_dummy, &dpms_dummy)) &&
                            (DPMSCapable (d)))
                        {
                              DPMSInfo (d, &dpms_state, &dpms_on);
                              DPMSDisable (d);
                        }
#endif
                        usleep(100000);XFlush(d);
			wsizew=fs_width&0xfffffffc;wsizeh=fs_height&0xfffffffc;;
                        setimagesize (fs_width,fs_height);


		  } else {
                           XSetScreenSaver (d, timeout, interval, prefer_blanking,
                           allow_exposures);
#ifdef HAVE_LIBXDPMS
                           if ((DPMSQueryExtension (d, &dpms_dummy, &dpms_dummy)) &&
                              (DPMSCapable (d)) && (dpms_on))
                           {
                              DPMSEnable (d);
                           }
#endif
                           XMoveResizeWindow(d, w,swxr,swyr, swrw, swrh);
			   XSync(d,True);XSync(d,True);XSync(d,True); XSync(d,True);
                           if (mouse_hide) {
				            XUndefineCursor(d,w);  mouse_hide=0;
				           }
                           usleep(100000);XFlush(d);
			   wsizeh=swrh&0xfffffffc;;wsizew=swrw&0xfffffffc;;
                           setimagesize (swrw,swrh);

                        }

                       if (debug){
                          if (fs)
                             fprintf(stderr,"Fullscreen off\n");
                          else  fprintf(stderr,"Fullscreen on\n");
                       }
               }
               break;

                case XK_L: case XK_l:
                   sprintf(status_bar,"Taztv : %s : %d fps",get_current_tv_channel(NULL),last_fps);
		   switch (plug_decoder) {
                         case 0:
                            strcat(status_bar," - std decode");
                         break;

                         case 1:
                            strcat(status_bar," - mm decode");
                         break;
                    }
                   print_status_bar(status_bar);
                break;

/* Meuhmeuh */
                case XK_F1:
                   plug_decoder++;
                   if (plug_decoder==2) plug_decoder=0 ;
                   switch (plug_decoder) {
                         case 0:
                            print_status_bar("Dcodeur standard activ");
                         break;

                         case 1:
                            print_status_bar("Dcodeur MeuhMeuh activ");
                         break;
                   }
                break;
               case XK_F2:
                   if (plug_decoder!=1) break;
                   switch (toggle_meuhmeuh_filtersecam()) {
                         case 1:
                            print_status_bar("Filtre secam activ");
                         break;

                         case 0:
                            print_status_bar("Filtre secam dsactiv");
                         break;
                }
               break;
              case XK_F3:
                   if (plug_decoder!=1) break;
                   switch (toggle_meuhmeuh_filterpurple()) {
                         case 1:
                            print_status_bar("Filtre violet activ");
                         break;

                         case 0:
                            print_status_bar("Filtre violet dsactiv");
                         break;
                }
               break;
              case XK_F4:
                   if (plug_decoder!=1) break;
                   switch (toggle_meuhmeuh_filteraverage()) {
                         case 1:
                            print_status_bar("Filtre moyenneur activ");
                         break;

                         case 0:
                            print_status_bar("Filtre moyenneur dsactiv");
                         break;
                }
               break;
/* fin meuhmeuh */
               case XK_Insert:
                   sprintf(status_bar,_("Number couples : %d"),INC_couples());
                   print_status_bar(status_bar);
               break;

                case XK_Delete:
                   sprintf(status_bar,_("Number couples : %d"),DEC_couples());
                   print_status_bar(status_bar);
               break;

               case  XK_Escape: case XK_Q: case XK_q:
		          not_end_taztv = 0;
                          return -1;
               break;


                case XK_KP_0: case XK_KP_Insert:
                    set_keypad_channel(0);
                break;

               case XK_KP_1: case XK_KP_End:
                    set_keypad_channel(1);
               break;

               case XK_KP_2: case XK_KP_Down:
                    set_keypad_channel(2);
               break;

               case XK_KP_3: case XK_KP_Next:
                    set_keypad_channel(3);
               break;

               case XK_KP_4: case XK_KP_Left:
                    set_keypad_channel(4);
               break;

               case XK_KP_5: case XK_KP_Begin:
                    set_keypad_channel(5);
               break;

               case XK_KP_6: case XK_KP_Right:
                    set_keypad_channel(6);
               break;

               case XK_KP_7: case XK_KP_Home:
                    set_keypad_channel(7);
               break;

               case XK_KP_8: case XK_KP_Up:
                    set_keypad_channel(8);
               break;

               case XK_KP_9: case XK_KP_Prior:
                    set_keypad_channel(9);
               break;

               case XK_Right:
                    sprintf(status_bar,"%s",inc_tv_channel());
                    print_status_bar(status_bar);
               break;

               case XK_Left:
                    sprintf(status_bar,"%s",dec_tv_channel());
                    print_status_bar(status_bar);
               break;

               case XK_KP_Add:
                    tv_two_number=ON;
                    print_status_bar(_("Two numbers for a channel"));
                    num_tv_two_number=-1;
               break;

               case XK_KP_Subtract:
                    tv_two_number=OFF;
                    print_status_bar(_("One number for a channel"));
               break;

               case XK_Up:
                    sprintf(status_bar,_("Mixer volume : %d "),inc_mixer_volume());
                    print_status_bar(status_bar);
               break;

               case XK_Down:
                    sprintf(status_bar,_("Mixer volume : %d "),dec_mixer_volume());
                    print_status_bar(status_bar);
               break;


         }
    break;
    }
  }

  if (XCheckTypedWindowEvent(d,w,ClientMessage,&e)) not_end_taztv = 0;

 return 0;
}

/************************************************************************/
int end_x11() {
    lirc_tv_deinit();
    stop_alevt();
    abort_channel_list_gui();
    abort_main_gui();
    end_gui();

#ifdef HAVE_LIBXXF86VM
    if (fs && have_vm && vm_switched)
        {
          set_vidmode (0);
          vm_switched = 0;
          if (vm_modelines) { XFree(vm_modelines); vm_count=0;vm_modelines=NULL; }
        }
#endif

#ifdef HAVE_XV
    if (xvport!=-1) XvUngrabPort (d, xvport, CurrentTime);
#endif
    XDestroy_image();
    XFreeFont(d,fd);
    XDestroyWindow (d,w);
#ifdef HAVE_XPM
    XFreePixmap(d,icon_pixmap);
    XFreePixmap(d,icon_shapemask);
#endif
    XFreeGC(d,gc);
    XCloseDisplay(d);

 return 0;
}




