/*************************************************************************
* yuyv2rgb.c                                                             *
* Maupatz  Keuleu  2001                                                  *
* taztv is free software; you can redistribute it and/or modify          *
* it under the terms of the GNU General Public License as published by   *
* the Free Software Foundation; either version 2 of the License, or      *
* (at your option) any later version.                                    *
*                                                                        *
* Taztv is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
* GNU General Public License for more details.                           *
*                                                                        *
* You should have received a copy of the GNU General Public License      *
* along with this program; if not, write to the Free Software            *
*                                                                        *
*************************************************************************/


#include "attributes.h"
#include "mmx.h"
#include "yuyv2rgb.h"
#include "taztv.h"


static   long long int masque5=0x00ff00ff00ff00ff;
static   long long int masque6=0x000000000000ffff;
static   long long int masque7=0x0000ff210085feeb;

static int  ttc[16];
static int  attc[16];
static int  ntc=0;
static int  sw_dst=0;
static int  sw_src=0;
static int  cp=0;

/*****************************RGB 24 Stuff**************************/
void putlineYUY2toRGB32(char *dst, int w_dst, char *src, int w_src){

      int xs,xd;
      int count;
      int *psrc;
      int *pdst;

      movq_m2r(masque7,mm7);
      movq_m2r(masque6,mm6);
      movq_m2r(masque5,mm5);

      psrc = (int *) src;
      pdst = (int *) dst;

      if (w_dst >= w_src) /* agrandissement */
       {
          /* petite optimisation */

         if  ( (sw_src!=w_src) || (sw_dst!=w_dst) ) {

	   cp = w_dst /  w_src; /* nombre fois pour copier la ligne principale */
           xd = w_src * cp;

           /* fait une curieuse approximation w_dst en fonction de w_src */
           memset(ttc,0,sizeof(ttc));
           ntc=0;
           count = 2;
           while (xd < w_dst ){
                       while ((xd + w_src / count) > w_dst ) count ++;
                       xd += w_src / count;
                       ttc[ntc] = count;
                       ntc++;
           }
           sw_src=w_src; sw_dst=w_dst;
                                                   }

          for (count=0; count < ntc; count ++) attc[count]=ttc[count];

          xd=0;

	  for (xs=0; xs < w_src; xs++)
	    {
                    if (xs & 1)
                          {
                    /*Pixel 2*/
                    psrc ++;
                    movq_r2r(mm0,mm3);
                    psrlq_i2r(16,mm3);
                           }
                    else {
                    movd_m2r(*psrc,mm0);
                    movq_r2r(mm0,mm1);
                    pand_r2r(mm5,mm0);
                    psrlw_i2r(8,mm1);

                      /*Pixel 1*/
                    movq_r2r(mm0,mm3);
                         }

                    movq_r2r(mm7,mm2);
                    pand_r2r(mm6,mm3);
                    movq_r2r(mm3,mm4);
                    psrlq_i2r(2,mm4);
                    paddw_r2r(mm4,mm3);  /* y0+1/4 y0*/
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* y0 + mm7 */

                    movq_r2r(mm1,mm3);
                    pand_r2r(mm6,mm3);   /* Cb */
                    movq_r2r(mm3,mm4);
                    psllw_i2r(1,mm3);
                    paddw_r2r(mm3,mm2);  /*  B calcul */

                    psllq_i2r(16,mm4);
                    psrlw_i2r(1,mm4);
                    psubw_r2r(mm4,mm2);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);

                    movq_r2r(mm1,mm3);
                    psrlq_i2r(16,mm3);
                    pand_r2r(mm6,mm3);  /* Cr */
                    psllq_i2r(16,mm3);
                    movq_r2r(mm3,mm4);
                    psubw_r2r(mm3,mm2); /*  G calcul */

                    psrlw_i2r(1,mm4);
                    paddw_r2r(mm4,mm3);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);
                    paddw_r2r(mm4,mm3);

                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* R calcul */

                    packuswb_r2r(mm2,mm2);
                    movd_r2m (mm2,*pdst);
                    pdst ++;

                    xd ++;
                    if (xd>=w_dst) { emms();  return; }

               for (count=0; count < (cp - 1); count ++) {
                                  *pdst =*(pdst - 1);
                                  pdst ++;
                                  xd ++;
                                  if (xd>=w_dst) { emms();  return;}
              }

              /* fait l'interpolation */
             for (count=0;count<ntc;count++) {
              attc[count]--;
	      if (attc[count] == 0 )
		{
                 attc[count]=ttc[count];
                 *pdst=*(pdst-1);
                 pdst ++;
                 xd ++;
                 if (xd>=w_dst) { emms();  return; }
                }
             }
            }
       }

 else /* plus petit */
       {
          sw_src=0;
          count = w_src >> 1;
	  for (xs=0; xs < w_src; xs++)
	    {
	      if (xs & 1)
                          {
                    /*Pixel 2*/
                    psrc ++;
                    movq_r2r(mm0,mm3);
                    psrlq_i2r(16,mm3);
                           }
                    else {
                    movd_m2r(*psrc,mm0);
                    movq_r2r(mm0,mm1);
                    pand_r2r(mm5,mm0);
                    psrlw_i2r(8,mm1);

                      /*Pixel 1*/
                    movq_r2r(mm0,mm3);
                          }

              count += w_dst;
	      if (count >= w_src)
		{

                    movq_r2r(mm7,mm2);
                    pand_r2r(mm6,mm3);
                    movq_r2r(mm3,mm4);
                    psrlq_i2r(2,mm4);
                    paddw_r2r(mm4,mm3);  /* y0+1/4 y0*/
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* y0 + mm7 */

                    movq_r2r(mm1,mm3);
                    pand_r2r(mm6,mm3);   /* Cb */
                    movq_r2r(mm3,mm4);
                    psllw_i2r(1,mm3);
                    paddw_r2r(mm3,mm2);  /*  B calcul */

                    psllq_i2r(16,mm4);
                    psrlw_i2r(1,mm4);
                    psubw_r2r(mm4,mm2);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);

                    movq_r2r(mm1,mm3);
                    psrlq_i2r(16,mm3);
                    pand_r2r(mm6,mm3);  /* Cr */
                    psllq_i2r(16,mm3);
                    movq_r2r(mm3,mm4);
                    psubw_r2r(mm3,mm2); /*  G calcul */

                    psrlw_i2r(1,mm4);
                    paddw_r2r(mm4,mm3);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);
                    paddw_r2r(mm4,mm3);

                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* R calcul */

                    packuswb_r2r(mm2,mm2);
                    movd_r2m (mm2,*pdst);

                    pdst++;

		    count -= w_src;
		}
	   }
	}

  emms();
}

/*****************************RGB 16 Stuff  ******************************/
void putlineYUY2toRGB16(char *dst, int w_dst, char *src, int w_src){

      int xs,xd;
      int count;
      int   *psrc;
      short *pdst;

      movq_m2r(masque7,mm7);
      movq_m2r(masque6,mm6);
      movq_m2r(masque5,mm5);

      psrc = (int   *) src;
      pdst = (short *) dst;

      if (w_dst >= w_src) /* agrandissement */
       {
          /* petite optimisation */

         if  ( (sw_src!=w_src) || (sw_dst!=w_dst) ) {

	   cp = w_dst /  w_src; /* nombre fois pour copier la ligne principale */
           xd = w_src * cp;

           /* fait une curieuse approximation w_dst en fonction de w_src */
           memset(ttc,0,sizeof(ttc));
           ntc=0;
           count = 2;
           while (xd < w_dst ){
                       while ((xd + w_src / count) > w_dst ) count ++;
                       xd += w_src / count;
                       ttc[ntc] = count;
                       ntc++;
           }
           sw_src=w_src; sw_dst=w_dst;
                                                   }

          for (count=0; count < ntc; count ++) attc[count]=ttc[count];

           xd=0;

	   for (xs=0; xs < w_src; xs++)
	    {
                    if (xs & 1)
                          {
                    /*Pixel 2*/
                    psrc ++;
                    movq_r2r(mm0,mm3);
                    psrlq_i2r(16,mm3);
                           }
                    else {
                    movd_m2r(*psrc,mm0);
                    movq_r2r(mm0,mm1);
                    pand_r2r(mm5,mm0);
                    psrlw_i2r(8,mm1);

                      /*Pixel 1*/
                    movq_r2r(mm0,mm3);
                         }

                    movq_r2r(mm7,mm2);
                    pand_r2r(mm6,mm3);
                    movq_r2r(mm3,mm4);
                    psrlq_i2r(2,mm4);
                    paddw_r2r(mm4,mm3);  /* y0+1/4 y0*/
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* y0 + mm7 */

                    movq_r2r(mm1,mm3);
                    pand_r2r(mm6,mm3);   /* Cb */
                    movq_r2r(mm3,mm4);
                    psllw_i2r(1,mm3);
                    paddw_r2r(mm3,mm2);  /*  B calcul */

                    psllq_i2r(16,mm4);
                    psrlw_i2r(1,mm4);
                    psubw_r2r(mm4,mm2);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);

                    movq_r2r(mm1,mm3);
                    psrlq_i2r(16,mm3);
                    pand_r2r(mm6,mm3);  /* Cr */
                    psllq_i2r(16,mm3);
                    movq_r2r(mm3,mm4);
                    psubw_r2r(mm3,mm2); /*  G calcul */

                    psrlw_i2r(1,mm4);
                    paddw_r2r(mm4,mm3);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);
                    paddw_r2r(mm4,mm3);

                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* R calcul */

                    packuswb_r2r(mm2,mm2);

                    movq_r2r(mm2,mm3);
                    pand_r2r(mm5,mm3);
                    psrlw_i2r(3,mm3);     /* B */

                    movq_r2r(mm3,mm4);
                    psrld_i2r(5,mm4);
                    por_r2r(mm4,mm3);    /* R */

                    psrlw_i2r(8,mm2);
                    pand_r2r(mm5,mm2);
                    pand_r2r(mm6,mm2);
                    psrlw_i2r(2,mm2);
                    psllw_i2r(5,mm2);    /* G */

                    por_r2r(mm3,mm2);    /* BGR 16 bits */

                    __asm__ __volatile__ (
                    "movd %%mm2,%%eax\n\t"
                    "movw %%ax,%0\n\t"
                    : "=g" (*pdst) : : "eax"
                     );

                 //   movd_r2m (mm2,*pdst);

                    pdst ++;

                    xd ++;
                    if (xd>=w_dst) { emms();  return; }

               for (count=0; count < (cp - 1); count ++) {
                                  *pdst=*(pdst - 1);
                                  pdst ++;
                                  xd ++;
                                  if (xd>=w_dst) { emms();  return;}
              }

              /* fait l'interpolation */
             for (count=0;count<ntc;count++) {
              attc[count]--;
	      if (attc[count] == 0 )
		{
                 attc[count]=ttc[count];
                 *pdst=*(pdst - 1);
                 pdst ++;
                 xd ++;
                 if (xd>=w_dst) { emms();  return; }
                }
             }
          }
       }

 else /* plus petit */
       {
          sw_src=0;
          count = w_src >> 1;
	  for (xs=0; xs < w_src; xs++)
	    { 		
		    if (xs & 1)
                          {
                    /*Pixel 2*/
                    psrc ++;
                    movq_r2r(mm0,mm3);
                    psrlq_i2r(16,mm3);
                           }
                    else {
                    movd_m2r(*psrc,mm0);
                    movq_r2r(mm0,mm1);
                    pand_r2r(mm5,mm0);
                    psrlw_i2r(8,mm1);

                      /*Pixel 1*/
                    movq_r2r(mm0,mm3);
                         }

	      count += w_dst;

	      if (count >= w_src)
		{

                    movq_r2r(mm7,mm2);
                    pand_r2r(mm6,mm3);
                    movq_r2r(mm3,mm4);
                    psrlq_i2r(2,mm4);
                    paddw_r2r(mm4,mm3);  /* y0+1/4 y0*/
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* y0 + mm7 */

                    movq_r2r(mm1,mm3);
                    pand_r2r(mm6,mm3);   /* Cb */
                    movq_r2r(mm3,mm4);
                    psllw_i2r(1,mm3);
                    paddw_r2r(mm3,mm2);  /*  B calcul */

                    psllq_i2r(16,mm4);
                    psrlw_i2r(1,mm4);
                    psubw_r2r(mm4,mm2);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);

                    movq_r2r(mm1,mm3);
                    psrlq_i2r(16,mm3);
                    pand_r2r(mm6,mm3);  /* Cr */
                    psllq_i2r(16,mm3);
                    movq_r2r(mm3,mm4);
                    psubw_r2r(mm3,mm2); /*  G calcul */

                    psrlw_i2r(1,mm4);
                    paddw_r2r(mm4,mm3);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);
                    paddw_r2r(mm4,mm3);

                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* R calcul */

                    packuswb_r2r(mm2,mm2);

                    movq_r2r(mm2,mm3);
                    pand_r2r(mm5,mm3);
                    psrlw_i2r(3,mm3);     /* B */

                    movq_r2r(mm3,mm4);
                    psrld_i2r(5,mm4);
                    por_r2r(mm4,mm3);    /* R */

                    psrlw_i2r(8,mm2);
                    pand_r2r(mm5,mm2);
                    pand_r2r(mm6,mm2);
                    psrlw_i2r(2,mm2);
                    psllw_i2r(5,mm2);    /* G */

                    por_r2r(mm3,mm2);    /* BGR 16 bits */

                     __asm__ __volatile__ (
                    "movd %%mm2,%%eax\n\t"
                    "movw %%ax,%0\n\t"
                    : "=g" (*pdst) : : "eax"
                     );

                //   movd_r2m (mm2,*pdst);

                    pdst++;

		    count -= w_src;
		  }
	    }
	}
  emms();
}

/*************************** End  RGB 16 Stuff **************************/


/*****************************RGB 15 Stuff  ******************************/
void putlineYUY2toRGB15(char *dst, int w_dst, char *src, int w_src){

      int xs,xd;
      int count;
      int   *psrc;
      short *pdst;

      movq_m2r(masque7,mm7);
      movq_m2r(masque6,mm6);
      movq_m2r(masque5,mm5);

      psrc = (int   *) src;
      pdst = (short *) dst;

      if (w_dst >= w_src) /* agrandissement */
       {
          /* petite optimisation */

         if  ( (sw_src!=w_src) || (sw_dst!=w_dst) ) {

	   cp = w_dst /  w_src; /* nombre fois pour copier la ligne principale */
           xd = w_src * cp;

           /* fait une curieuse approximation w_dst en fonction de w_src */
           memset(ttc,0,sizeof(ttc));
           ntc=0;
           count = 2;
           while (xd < w_dst ){
                       while ((xd + w_src / count) > w_dst ) count ++;
                       xd += w_src / count;
                       ttc[ntc] = count;
                       ntc++;
           }
           sw_src=w_src; sw_dst=w_dst;
                                                   }

          for (count=0; count < ntc; count ++) attc[count]=ttc[count];

           xd=0;

	   for (xs=0; xs < w_src; xs++)
	    {
                    if (xs & 1)
                          {
                    /*Pixel 2*/
                    psrc ++;
                    movq_r2r(mm0,mm3);
                    psrlq_i2r(16,mm3);
                           }
                    else {
                    movd_m2r(*psrc,mm0);
                    movq_r2r(mm0,mm1);
                    pand_r2r(mm5,mm0);
                    psrlw_i2r(8,mm1);

                      /*Pixel 1*/
                    movq_r2r(mm0,mm3);
                         }

                    movq_r2r(mm7,mm2);
                    pand_r2r(mm6,mm3);
                    movq_r2r(mm3,mm4);
                    psrlq_i2r(2,mm4);
                    paddw_r2r(mm4,mm3);  /* y0+1/4 y0*/
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* y0 + mm7 */

                    movq_r2r(mm1,mm3);
                    pand_r2r(mm6,mm3);   /* Cb */
                    movq_r2r(mm3,mm4);
                    psllw_i2r(1,mm3);
                    paddw_r2r(mm3,mm2);  /*  B calcul */

                    psllq_i2r(16,mm4);
                    psrlw_i2r(1,mm4);
                    psubw_r2r(mm4,mm2);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);

                    movq_r2r(mm1,mm3);
                    psrlq_i2r(16,mm3);
                    pand_r2r(mm6,mm3);  /* Cr */
                    psllq_i2r(16,mm3);
                    movq_r2r(mm3,mm4);
                    psubw_r2r(mm3,mm2); /*  G calcul */

                    psrlw_i2r(1,mm4);
                    paddw_r2r(mm4,mm3);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);
                    paddw_r2r(mm4,mm3);

                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* R calcul */

                    packuswb_r2r(mm2,mm2);

                    movq_r2r(mm2,mm3);
                    pand_r2r(mm5,mm3);
                    psrlw_i2r(3,mm3);     /* B */

                    movq_r2r(mm3,mm4);
                    psrld_i2r(6,mm4);
                    por_r2r(mm4,mm3);    /* R */

                    psrlw_i2r(8,mm2);
                    pand_r2r(mm5,mm2);
                    pand_r2r(mm6,mm2);
                    psrlw_i2r(3,mm2);
                    psllw_i2r(5,mm2);    /* G */

                    por_r2r(mm3,mm2);    /* BGR 15 bits */

                    __asm__ __volatile__ (
                    "movd %%mm2,%%eax\n\t"
                    "movw %%ax,%0\n\t"
                    : "=g" (*pdst) : : "eax"
                     );

               //     movd_r2m (mm2,*pdst);
                    pdst ++;

                    xd ++;
                    if (xd>=w_dst) { emms();  return; }

               for (count=0; count < (cp - 1); count ++) {
                                  *pdst = *(pdst - 1);
                                  pdst ++;
                                  xd ++;
                                  if (xd>=w_dst) { emms();  return;}
              }

              /* fait l'interpolation */
             for (count=0;count<ntc;count++) {
              attc[count]--;
	      if (attc[count] == 0 )
		{
                 attc[count]=ttc[count];
                 *pdst = *(pdst-1);
                 pdst ++;
                 xd ++;
                 if (xd>=w_dst) { emms();  return; }
                }
              }
            }
       }

 else /* plus petit */
       {
          sw_src=0;
          count = w_src >> 1;

	  for (xs=0; xs < w_src; xs++)
	    {
               if (xs & 1)
                          {
                    /*Pixel 2*/
                    psrc ++;
                    movq_r2r(mm0,mm3);
                    psrlq_i2r(16,mm3);
                           }
                    else {
                    movd_m2r(*psrc,mm0);
                    movq_r2r(mm0,mm1);
                    pand_r2r(mm5,mm0);
                    psrlw_i2r(8,mm1);

                      /*Pixel 1*/
                    movq_r2r(mm0,mm3);
                         }

	      count += w_dst;
	      if (count >= w_src)
		{ 		
		
                    movq_r2r(mm7,mm2);
                    pand_r2r(mm6,mm3);
                    movq_r2r(mm3,mm4);
                    psrlq_i2r(2,mm4);
                    paddw_r2r(mm4,mm3);  /* y0+1/4 y0*/
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);
                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* y0 + mm7 */

                    movq_r2r(mm1,mm3);
                    pand_r2r(mm6,mm3);   /* Cb */
                    movq_r2r(mm3,mm4);
                    psllw_i2r(1,mm3);
                    paddw_r2r(mm3,mm2);  /*  B calcul */

                    psllq_i2r(16,mm4);
                    psrlw_i2r(1,mm4);
                    psubw_r2r(mm4,mm2);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);

                    movq_r2r(mm1,mm3);
                    psrlq_i2r(16,mm3);
                    pand_r2r(mm6,mm3);  /* Cr */
                    psllq_i2r(16,mm3);
                    movq_r2r(mm3,mm4);
                    psubw_r2r(mm3,mm2); /*  G calcul */

                    psrlw_i2r(1,mm4);
                    paddw_r2r(mm4,mm3);
                    psrlw_i2r(2,mm4);
                    paddw_r2r(mm4,mm2);
                    paddw_r2r(mm4,mm3);

                    psllq_i2r(16,mm3);
                    paddw_r2r(mm3,mm2);  /* R calcul */

                    packuswb_r2r(mm2,mm2);

                    movq_r2r(mm2,mm3);
                    pand_r2r(mm5,mm3);
                    psrlw_i2r(3,mm3);     /* B */

                    movq_r2r(mm3,mm4);
                    psrld_i2r(6,mm4);
                    por_r2r(mm4,mm3);    /* R */

                    psrlw_i2r(8,mm2);
                    pand_r2r(mm5,mm2);
                    pand_r2r(mm6,mm2);
                    psrlw_i2r(3,mm2);
                    psllw_i2r(5,mm2);    /* G */

                    por_r2r(mm3,mm2);    /* BGR 15 bits */
                     __asm__ __volatile__ (
                    "movd %%mm2,%%eax\n\t"
                    "movw %%ax,%0\n\t"
                    : "=g" (*pdst) : : "eax"
                     );
                     //       movd_r2m (mm2,*pdst);
                    pdst++;

		    count -= w_src;
                }
	    }
	}

  emms();
}

/*************************** End  RGB 15 Stuff **************************/
